package com.acme.randomstringwsproviderundertow;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.acme.randomstringwsproviderundertow.configuration.UndertowServerDeployment;
import com.acme.randomstringwsproviderundertow.websocket.RandomStringWebSocketCallback;

public class RandomStringWsProviderUndertowApplication {

    private static final Logger LOGGER = LoggerFactory.getLogger( RandomStringWebSocketCallback.class );
    private static final String DEFAULT_HOST = "localhost";
    private static final int DEFAULT_PORT = 8193;

    public static void main( String[] args ) {
        final UndertowServerDeployment undertowServerDeployment = createUndertowServerDeployment( args );
        undertowServerDeployment.start();
    }

    private static UndertowServerDeployment createUndertowServerDeployment( final String[] args ) {
        if ( args.length != 2 ) {
            LOGGER.warn( "Host and/or port is missing. Undertow server will be started with the default endpoint configuration." );
            return new UndertowServerDeployment( DEFAULT_HOST, DEFAULT_PORT );
        } else {
            return new UndertowServerDeployment( args[0], Integer.parseInt( args[1] ) );
        }
    }

}
