/*
 * CorsProperties.java
 *
 * Copyright (c) 2018 by General Electric Company. All rights reserved.
 *
 * The copyright to the computer software herein is the property of
 * General Electric Company. The software may be used and/or copied only
 * with the written permission of General Electric Company or in accordance
 * with the terms and conditions stipulated in the agreement/contract
 * under which the software has been supplied.
 */
package com.acme.wsapigatewaytomcat.configuration;

import java.util.List;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

import com.google.common.collect.ImmutableList;

@Configuration
@ConfigurationProperties( prefix = "security.cors" )
public class CorsProperties {

    private List<String> allowedOrigins;
    private List<String> allowedMethods;
    private List<String> allowedHeaders;
    private Boolean allowCredentials;
    private Long maxAge;

    public List<String> getAllowedOrigins() {
        return ImmutableList.copyOf( allowedOrigins );
    }

    public void setAllowedOrigins( List<String> allowedOrigins ) {
        this.allowedOrigins = ImmutableList.copyOf( allowedOrigins );
    }

    public List<String> getAllowedMethods() {
        return ImmutableList.copyOf( allowedMethods );
    }

    public void setAllowedMethods( List<String> allowedMethods ) {
        this.allowedMethods = ImmutableList.copyOf( allowedMethods );
    }

    public List<String> getAllowedHeaders() {
        return ImmutableList.copyOf( allowedHeaders );
    }

    public void setAllowedHeaders( List<String> allowedHeaders ) {
        this.allowedHeaders = ImmutableList.copyOf( allowedHeaders );
    }

    public Boolean getAllowCredentials() {
        return allowCredentials;
    }

    public void setAllowCredentials( Boolean allowCredentials ) {
        this.allowCredentials = allowCredentials;
    }

    public Long getMaxAge() {
        return maxAge;
    }

    public void setMaxAge( Long maxAge ) {
        this.maxAge = maxAge;
    }

    @Override
    public String toString() {
        return "CorsProperties{" +
                "allowedOrigins=" + allowedOrigins +
                ", allowedMethods=" + allowedMethods +
                ", allowedHeaders=" + allowedHeaders +
                ", allowCredentials=" + allowCredentials +
                ", maxAge=" + maxAge +
                '}';
    }
}
