package com.acme.wsapigatewaytomcat.configuration;

import javax.websocket.ContainerProvider;
import javax.websocket.WebSocketContainer;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.socket.client.WebSocketClient;
import org.springframework.web.socket.client.standard.StandardWebSocketClient;

@Configuration
public class WebSocketClientConfiguration {

    private final int messageBufferSize;

    @Autowired
    public WebSocketClientConfiguration( @Value( "${configuration.webSocket.messageBufferSize}" ) final int messageBufferSize ) {
        this.messageBufferSize = messageBufferSize;
    }

    @Bean
    public WebSocketClient createWebSocketClient() {
        final WebSocketContainer container = ContainerProvider.getWebSocketContainer();
        container.setDefaultMaxTextMessageBufferSize( messageBufferSize );
        container.setDefaultMaxBinaryMessageBufferSize( messageBufferSize );
        return new StandardWebSocketClient( container );
    }

}
