/********************************************************************************
 * WebSocketExtensionsHeaderWrapper.java                                           *
 *                                                                              *
 * Copyright (c) 2020 by General Electric Company. All rights reserved.         *
 *                                                                              *
 * The copyright to the computer software herein is the property of             *
 * General Electric Company. The software may be used and/or copied only        *
 * with the written permission of General Electric Company or in accordance     *
 * with the terms and conditions stipulated in the agreement/contract           *
 * under which the software has been supplied.                                  *
 ********************************************************************************/

package com.acme.wsapigatewaytomcat.websocket;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

import org.apache.tomcat.websocket.Constants;

public class WebSocketExtensionsHeaderWrapper extends HttpServletRequestWrapper {

    private List<String> extensions = new ArrayList<>();

    public WebSocketExtensionsHeaderWrapper( final HttpServletRequest request ) {
        super( request );
        Enumeration<String> extHeaders = request.getHeaders( Constants.WS_EXTENSIONS_HEADER_NAME );
        while ( extHeaders.hasMoreElements() ) {
            extensions.add( extHeaders.nextElement() );
        }
    }

    @Override
    public Enumeration<String> getHeaders( final String name ) {
        if ( name.equalsIgnoreCase( Constants.WS_EXTENSIONS_HEADER_NAME ) ) {
            return Collections.enumeration( extensions );
        }
        return super.getHeaders( name );
    }

    public void setExtensions( final List<String> extension ) {
        this.extensions = new ArrayList<>( extension );
    }

}