/********************************************************************************
 * WebSocketExtensionsHeaderWrapperFilter.java                                  *
 *                                                                              *
 * Copyright (c) 2020 by General Electric Company. All rights reserved.         *
 *                                                                              *
 * The copyright to the computer software herein is the property of             *
 * General Electric Company. The software may be used and/or copied only        *
 * with the written permission of General Electric Company or in accordance     *
 * with the terms and conditions stipulated in the agreement/contract           *
 * under which the software has been supplied.                                  *
 ********************************************************************************/

package com.acme.wsapigatewaytomcat.websocket;

import java.io.IOException;

import javax.servlet.FilterChain;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.core.Ordered;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
import org.springframework.web.filter.OncePerRequestFilter;

@Component
@Order( Ordered.LOWEST_PRECEDENCE )
public class WebSocketExtensionsHeaderWrapperFilter extends OncePerRequestFilter {

    @Override
    protected void doFilterInternal( final HttpServletRequest request, final HttpServletResponse response, final FilterChain filterChain ) throws ServletException, IOException {
        filterChain.doFilter( new WebSocketExtensionsHeaderWrapper( request ), response );
    }

}
